#!/bin/sh
###
# Findpath - скрипт для нахождения пакета по известной части пути файла в пакете
###
# Copyright (C) 2016 Serg A. Kotlyarov <shadowsbrother@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

aptrepo=/usr/bin/apt-repo
cut=/bin/cut
grep=/bin/grep
mkdir=/bin/mkdir
printenv=/usr/bin/printenv
sed=/bin/sed
sort=/bin/sort
tr=/usr/bin/tr
wc=/bin/wc
wget=/usr/bin/wget

get_index () {
$wget -c -P $basedir/$repocount/$arch $url_arch
$wget -c -P $basedir/$repocount/noarch $url_noarch
}

home=`$printenv HOME`
ar=`$aptrepo`
index=contents_index
basedir=$home'/.'$index
[[ $basedir ]] || $mkdir $basedir
urls=`echo "$ar"|$cut -f3 -d' '`
urlscount=`echo "$urls"|wc -l`
for (( i=$urlscount; i > 0; i-- )); do
 url[i]=`echo "$urls"|sed -n $i'p;'$i'q'`
done
for (( j=1; j < $urlscount; j++)); do
 if [[ ${url[j]} ]]; then
  for (( k=$urlscount; k > $j; k--)); do
   [[ ${url[j]} == ${url[k]} ]] && url[k]=""
  done
 fi
done
for (( l=1; l <= $urlscount; l++)); do
 if [[ ${url[l]} ]]; then
  repocount=$(( $repocount + 1 ))
  url_noarch=${url[l]}'/noarch/base/'$index
  [[ `echo $ar|$grep x86_64` ]] && arch=x86_64
  [[ `echo $ar|$grep armh` ]] && arch=armh
  [[ `echo $ar|$grep i586` ]] && arch=i586
  url_arch=${url[l]}'/'$arch'/base/'$index
  index_arch=$basedir/$repocount/$arch/$index
  index_noarch=$basedir/$repocount/noarch/$index
  if [[ -e $index_arch && -e $index_noarch ]]; then
   p=
   echo -n "Найдены локальные файлы индексов для ${url[l]}, хотите обновить из репозитория?"\
        $'\n'"Пробел/Enter/Tab - обновить, любая другая клавиша - использовать локальные индексы: "
   read -s -n1 p
   echo
   [[ `echo "$p"|$tr -d '\040'` ]] && echo "Для поиска по индексу из ${url[l]} будут использованы имеющиеся локальные копии файлов" || get_index
  else
   echo "Локальные файлы индексов для ${url[l]} отсутствуют, выполняется загрузка файлов" && get_index
  fi
  if ! [[ $# == 0 ]]; then
   for n in $@; do
    echo
    for i in $arch noarch; do
     echo "Поиск по аргументу $n (${url[l]} $i):"
     grep "$n" $basedir/$repocount/$i/$index|$cut -f2|$sort -u
     echo
    done
   done
  fi
 fi
done